; additional routines for Prowess Sbasic interface
; this little routine gets a #memspace long memory block in the common heap
; puts the top of this area into A4, and stacks the bottom of the area on this,
; as well as some other registers and data (see below)
; D7 then points to this address
; in case of error, this does not return to caller, but to caller's caller
; which is normally the interpreter itself
; v. 1.01 1996 Aug 31 21:36:22
; copyright (c)  W. Lenerz 1996
; 04.08.1996 Joachim Van der Auwera : allow DLL linkage when called first

	section	text

	xdef	gmem
	xdef	gmem2
	include	asm_macro_jvda
	include	asm_includes_asm
	xref	gu_achp		; gets memory (gu_achp)


gmem
	test_dll
	MOVEQ	#0,D0
	TRAP	#1		; get sysinfo, especially my job ID...
	TST.L	D0		; which is placed into D1
	BNE.S	out		; oops
	MOVE.L	#memspace,D0
	JSR	gu_achp		; get memory
	BNE.S	out		; oops->...
gmem2	MOVE.L	A0,A4		; A4 points to ...
	ADD.L	#memspace,A4	; ... top of space
	MOVE.L	A4,(A0)		; bottom of stack points to top
	MOVE.L	#water1,-(A4)	; stack first part of watermark,and...
	MOVE.L	D1,-(A4)		; ...stack my job ID, and next part:...
	MOVE.L	#water2,-(A4)	; ...build a watermark on the stack
	MOVE.L	A0,-(A4)		; start of this space is kept here
	MOVE.L	A6,-(A4)		; keep my A6
	MOVE.L	A3,-(A4)		; keep pointer to data
	MOVE.L	A7,D1		; stack pointer IN THIS SUBROUTINE
	ADDQ.L	#4,D1
	MOVE.L	D1,-(A4)		; my true stack pointer is kept here
	MOVE.L	A4,D7		; keep this now
	ADDQ.L	#4,A0		; point after pointer to top
	TST.L	D0
exit	RTS

out2	MOVEQ	#-19,D0
out	ADDQ.L	#4,A7		; return to caller's caller
	RTS
	end


the "stack" looks as follows:
top -->	0	watermark 1
	-4	my job ID
	-8	watermark 2
	-12	pointer to bottom (A0)
	-16	my A6
	-20	my A3
	-24	my true A7


	(....)

	4 (sometimes)  pointer to false stack pointer (on reentry to pwactivate after false exit through hit routines)
bottom -> 0	pointer to top
